math.randomseed(os.time())
require ('camera')
require "json"

function love.load()
   grass = love.graphics.newImage("textures/grass.png")
   stone = love.graphics.newImage("textures/stone.png")
   dirt = love.graphics.newImage("textures/dirt.png")
   grid = love.graphics.newImage("textures/grid.png")
   guy_pic = love.graphics.newImage("textures/player_r.png")
   guy_pic_l = love.graphics.newImage("textures/player_l.png")
   menu = love.graphics.newImage("textures/selected.png")
   width = love.graphics.getWidth()
   height = love.graphics.getHeight()
   camera:setBounds(0, 0, 1920, 1920)
   
   	guy = { --The table for the player
		x = 32,
		y = 32,
		ySpeed = 0,
		grav = 1.5,
		width = 30,
		height = 30,
		direction = 0,
		}
	
   map = {}
   map.tiles = {}
   map.tiles.width, map.tiles.height = 32, 32 --Tiles width and height
   map.tiles.current = 2 -- This is the currently selected tile, the one you put when you click
   map.width = 80
   map.height = 80
   for x = 0, map.width do
      map[x] = {}
      for y = 0, map.height do
		 if x < 7 then
			map[x][y] = 1
		 else
			map[x][y] = math.random(4)
		 end
		 
		 if map[x][y] == 2 and map[x-1][y] > 1 then
			map[x][y] = 4
		 end
		 
		 if map[x][y] == 4 and map[x-1][y] == 1 then
			map[x][y] = 2
		 end
      end
   end
end

function love.draw()
		camera:set()
		for y = 0, map.height do
			for x = 0, map.width do
				if map[y][x] == 2 then
					if map[y-1][x] > 1 then
						map[y][x] = 4
					end
					love.graphics.draw(grass, x * 32, y * 32)
				end
				if map[y][x] == 3 then
					love.graphics.draw(stone, x * 32, y * 32)
				end
				if map[y][x] == 4 then
					if map[y-1][x] == 1 and (map[y][x+1] == 2 or map[y][x-1] == 2) then
						map[y][x] = 2
					end
					love.graphics.draw(dirt, x * 32, y * 32)
				end
				if map[y][x] == 1 then
					love.graphics.draw(grid, x * 32, y * 32)
				end
			end
		end
		
		local block_x = 64
		local block_y = 1
		love.graphics.print("FPS:"..love.timer.getFPS(), camera:RePositionX(0), camera:RePositionY(0))
		love.graphics.draw(menu, camera:RePositionX(block_x-1), camera:RePositionY(block_y-1))
		if map.tiles.current == 2 then
			love.graphics.draw(grass, camera:RePositionX(block_x), camera:RePositionY(block_y))
		elseif map.tiles.current == 3 then
			love.graphics.draw(stone, camera:RePositionX(block_x), camera:RePositionY(block_y))
		elseif map.tiles.current == 4 then
			love.graphics.draw(dirt, camera:RePositionX(block_x), camera:RePositionY(block_y))
		end
		
		if guy.direction == 0 then
			love.graphics.draw(guy_pic, guy.x, guy.y)
		else
			love.graphics.draw(guy_pic_l, guy.x, guy.y)
		end
		camera:unset()
end

function love.update(dt)
		dt = math.min(dt, 0.07)
		frame = dt * 30
		
		if guy.y < 1 then --Shove him back!!!!!
			guy.y = 20
		end
	    if guy.y > map.height * 32 - ( guy.height / 2 ) then
			guy.y = guy.y - 20
		end
		if guy.x < 1 then
			guy.x = 10
		end
		if guy.x > map.width * 32 - ( guy.width / 2 ) then
			guy.x = guy.x - 9 --This must be more than his speed forward
		end
		
		guy.ySpeed = guy.ySpeed + guy.grav * frame
		guy.y = guy.y + guy.ySpeed * frame
		boundingChecks()
		
		camera:setPosition(guy.x - width / 2, guy.y - height / 2)
end

function love.keypressed(key)
	if key == "1" then
		map.tiles.current = 2 
	end
	if key == "2" then
		map.tiles.current = 3 
	end
	if key == "3" then
		map.tiles.current = 4 
	end
	if key == "w" and guy.ySpeed == 0 then
			guy.ySpeed = -12
	end
end

function boundingChecks()
	if mapCollide(guy.x + 1, guy.y + guy.height, guy, map) == 2 or mapCollide(guy.x + guy.width - 1, guy.y + guy.height, guy, map) == 2 then
		guy.y = guy.y - guy.ySpeed * frame
		guy.ySpeed = 0
	end
	if mapCollide(guy.x + 1, guy.y, guy, map) == 2 or mapCollide(guy.x + guy.width, guy.y, guy, map) == 2 then
		guy.ySpeed = .5
	end
	if mapCollide(guy.x + 1, guy.y + guy.height, guy, map) == 3 or mapCollide(guy.x + guy.width - 1, guy.y + guy.height, guy, map) == 3 then
		guy.y = guy.y - guy.ySpeed * frame
		guy.ySpeed = 0
	end
	if mapCollide(guy.x + 1, guy.y, guy, map) == 3 or mapCollide(guy.x + guy.width, guy.y, guy, map) == 3 then
		guy.ySpeed = .5
	end
	if mapCollide(guy.x + 1, guy.y + guy.height, guy, map) == 4 or mapCollide(guy.x + guy.width - 1, guy.y + guy.height, guy, map) == 4 then
		guy.y = guy.y - guy.ySpeed * frame
		guy.ySpeed = 0
	end
	if mapCollide(guy.x + 1, guy.y, guy, map) == 4 or mapCollide(guy.x + guy.width, guy.y, guy, map) == 4 then
		guy.ySpeed = .5
	end
	if love.keyboard.isDown("a") then
		guy.x = guy.x - 8 * frame
		guy.direction = 1
	end
	if love.keyboard.isDown("d") then
		guy.x = guy.x + 8 * frame
		guy.direction = 0
	end
	if mapCollide(guy.x, guy.y + 1, guy, map) == 2 or mapCollide(guy.x, guy.y + guy.height - 1, guy, map) == 2 then
		guy.x = guy.x + 8 * frame
	end
	if mapCollide(guy.x + guy.width, guy.y + 1, guy, map) == 2 or mapCollide(guy.x + guy.width, guy.y + guy.height - 1, guy, map) == 2 then
		guy.x = guy.x - 8 * frame
	end
	if mapCollide(guy.x, guy.y + 1, guy, map) == 3 or mapCollide(guy.x, guy.y + guy.height - 1, guy, map) == 3 then
		guy.x = guy.x + 8 * frame
	end
	if mapCollide(guy.x + guy.width, guy.y + 1, guy, map) == 3 or mapCollide(guy.x + guy.width, guy.y + guy.height - 1, guy, map) == 3 then
		guy.x = guy.x - 8 * frame
	end
	if mapCollide(guy.x, guy.y + 1, guy, map) == 4 or mapCollide(guy.x, guy.y + guy.height - 1, guy, map) == 4 then
		guy.x = guy.x + 8 * frame
	end
	if mapCollide(guy.x + guy.width, guy.y + 1, guy, map) == 4 or mapCollide(guy.x + guy.width, guy.y + guy.height - 1, guy, map) == 4 then
		guy.x = guy.x - 8 * frame
	end
end

function mapCollide(x, y)--qualities
	local checkMap = map[math.floor(y/32)][math.floor(x/32)]
	return checkMap
end

function love.mousepressed( x, y, button )
    x = camera:RePositionX(x)
	y = camera:RePositionY(y)

	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)
	if button == 'l' and y > 32 and mapCollide(x, y) < 2 and ( map[mapX+1][mapY] > 1 or map[mapX-1][mapY] > 1 or map[mapX][mapY+1] > 1 or map[mapX][mapY-1] > 1 ) then
		map[mapX][mapY] = map.tiles.current
	end
	if button == 'r' and y > 32 then
		map[mapX][mapY] = 1
	end
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end

function love.quit()
end